/**
 * Executes only one instance of give code at a time. For parallel calls, it
 * returns the result of the ongoing execution.
 *
 * {@link mutex} can be used as a class method decorator or a higher order
 * function.
 */
export declare function mutex<This, Return>(target: (this: This) => Promise<Return>, context?: ClassMethodDecoratorContext<This, (this: This) => Promise<Return>>): (this: This) => Promise<Return>;
